import json
import requests, pickle
import sounddevice as sd
from config import config

fs = 16000  # Sample rate
seconds = 5  # Duration of recording
SERVER_URL = config.CLIENT_CONFIG['server_url']
INFERENCE_STR = config.CLIENT_CONFIG['inference_url']
TEST_STR = config.CLIENT_CONFIG['test_url']

## Record Part
print("start Recording")
audio = sd.rec(int(seconds * fs), samplerate=fs, channels=1)
sd.wait()

audio = audio.tolist()
# audio = pickle.dumps(audio).decode('utf8')
print("end Recording", type(audio), type(audio[0]), type(audio[0][0]))

payload = {
    "device":"0005",
    "time":"seconds",
    "recording":{
        "filename":"output.mp3",
        "content_type":"audio/mp3",
        "content": audio
    }
}
headers = {'Content-Type': 'application/json; charset=utf-8'}

r = requests.post(SERVER_URL + INFERENCE_STR, data=json.dumps(payload), headers=headers)
# r = requests.post(SERVER_URL + TEST_STR, data=payload, headers=headers)
resJson = r.json()
print(resJson)